#define F_CPU 14745600UL 																		/*    */

//#include "MC12D6R.h"
#include "MC4A7D4R4O.h"

#include <avr/io.h> 																			//  -
#include "LED.h"																				//   LED 
#include "RTC.h"																				/*      */
#include "Key.h"																				//   

uint8_t hour, min, sec;																			// , , 
uint8_t TimeSet=0;																				//   
uint8_t Error;																					//    RTC
char String[11];																				//   

int main(void)
{
	LED_Init();																					// 
	RTC_Init();																					// RTC
	Key_Init(LATCH_OFF);																		// 

	while(1)																					// 
	{
		Error=0;																				//   RTC
		if (RTC_Get_Time(&hour,&min,&sec)==1) Error=1;											//  , , 
		
//-----------------------------------  "" ---------------------------------------
		if (Key(3)==DOWN)																		// 3  ( )
		{
			while(Key(3)==DOWN);																//  
			TimeSet++;																			//   
			if (TimeSet>3) TimeSet=0;															//       
		}
//---------------------------------------  "+" -------------------------------------------
		if (Key(2)==DOWN)																		// 2 
		{
			switch(TimeSet)																		//  
			{
				case 0: break;																	//  (  )
				case 1:																			//  
				hour++;																			//  
				if (hour>23) hour=0;															// ,      
				if (RTC_Set_Time(hour,min,sec)==1) Error=1;										//   
				break;
				case 2:																			//  
				min++;																			//  
				if (min>59) min=0;																// ,      
				if (RTC_Set_Time(hour,min,sec)==1) Error=1;										//   
				break;
				case 3:																			//  
				sec=0;																			// 
				if (sec>30) min++;																// ,       
				if (min>59) {min=0; hour++;}													//   ,     
				if (hour>23) hour=0;															// ,     
				if (RTC_Set_Time(hour,min,sec)==1) Error=1;										//   
				break;
			}
			_delay_ms(100);																		// 
		}
//---------------------------------------  "-" -------------------------------------------
		if (Key(1)==DOWN)																		// 1 
		{
			switch(TimeSet)																		//  
			{
				case 0: break;																	//  (  )
				case 1:																			//  
				hour--;																			//  
				if (hour==255) hour=23;															// ,      
				if (RTC_Set_Time(hour,min,sec)==1) Error=1;										//   
				break;
				case 2:																			//  
				min--;																			//  
				if (min==255) min=59;															// ,      
				if (RTC_Set_Time(hour,min,sec)==1) Error=1;										//   
				break;
				case 3:																			//  
				sec=0;																			// 
				if (sec>30) min--;																// ,       
				if (min==255) {min=59; hour--;}													//   ,     
				if (hour==255) hour=0;															// ,     
				if (RTC_Set_Time(hour,min,sec)==1) Error=1;										//   
				break;
			}
			_delay_ms(100);																		// 
		}
		
		String[0]=hour/10+0x30;																	//     
		String[1]=hour%10+0x30;
		String[2]=':';																			// 
		
		String[3]=min/10+0x30;																	//     
		String[4]=min%10+0x30;
		String[5]=':';																			// 
		
		String[6]=sec/10+0x30;																	//     
		String[7]=sec%10+0x30;
		String[8]=0x20;																			// 
		String[9]=0x20;																			// 
		String[10]=0;																			//  
		
		if (Error==1)
		{
			LED_SetPos(0,0);																	//      
			LED_Write_String(" RTC");														//   
		}
		else
		{
			LED_SetPos(0,0);																	//      
			LED_Write_String(String);															//   
		
			switch(TimeSet)																		//  
			{
				case 0: LED_CursorEnable(0); break;												//  
				case 1: LED_CursorEnable(1); LED_SetPos(0,1); break;							//    
				case 2: LED_CursorEnable(1); LED_SetPos(0,4); break;							//    
				case 3: LED_CursorEnable(1); LED_SetPos(0,7); break;							//    
			}
		}

		Led(LD_SW);																				// 
		_delay_ms(100);																			// 
	}
}