#ifndef _MENU_																														//    
#define _MENU_ 

#ifndef F_CPU
# warning "F_CPU not defined. Frequency by default 14,7456MHz"
#define F_CPU 14745600UL																											// ,    (     )
#endif

#ifndef MAX_ELEMENTS_MENU
#warning "MAX_ELEMENTS not defined. Elements count by default 50"
#define MAX_ELEMENTS_MENU 50																										//,     
#endif

#ifndef MAX_SUB_MENUS
#warning "MAX_SUB_MENUS not defined. Elements count by default 10"
#define MAX_SUB_MENUS 10																											//,   
#endif

#ifndef MAX_HISTORY_ELEMENTS
#warning "MAX_HISTORY_ELEMENTS not defined"
#define MAX_HISTORY_ELEMENTS 16																										//,     
#endif

#ifndef MAX_HISTORY_NAMES 
#warning "MAX_HISTORY_NAMES  not defined"
#define MAX_HISTORY_NAMES  3																										//,         
#endif

#define MAX_WORD_LENGHT 8																											//,     

#define NONE 0																														// " "

#define OUT 0																														// "  "
#define IN 1																														// "  "
#define CHECK 2																														// ""
#define EXIT 65535																													// "  "

#include <avr/iom128.h>																												//  /
#include <util/delay.h>																												//  
#include "Key.h"																													//    
#include "LED.h"																													//    
																												
//--------------------------------------      -------------------------------------------------//
typedef enum																														//    
{
	EMPTY_ELEMENT = 0,																												// 
	PARAM_ELEMENT,																													//   
	SWITCH_ELEMENT,																													//- (/)
	DEFAULT_ELEMENT,																												//,    
	HISTORY_ELEMENT,																												//,   
	WORD_ELEMENT,																													//   
} menu_Types;

//-------------------------------------------    ---------------------------------------------------------//
enum Lib_Flags																														//  
{
	lib_Flag_Error = (1),																											// 
	lib_Flag_Set_Changes = (1 << 1),																								//    
	lib_Flag_Menu_Enable = (1 << 2),																								//  
	lib_Flag_Changing_Param = (1 << 3),																								//  
	lib_Flag_Save_Change = (1 << 4),																								//  
	lib_Flag_FIFO_End = (1 << 5),																									//    
	lib_Flag_Menu_Out = (1 << 6),
} my_Lib_Flags = 0;																													//    
					
//-----------------------------------------    -------------------------------------------------------//
uint8_t _temp_Array[8];																												//    
uint8_t _temp_Switch = 0;																											//-    
uint16_t _selected_Element = 0;																										//   

uint8_t _history_Buf_Param[MAX_HISTORY_ELEMENTS][MAX_WORD_LENGHT+1];																//     
uint8_t _history_Buf_Name[MAX_HISTORY_ELEMENTS][MAX_HISTORY_NAMES];																	//     

uint8_t _line2 = 0;																													//     
uint8_t _line = 0;																													//     

//----------------------------------------     -------------------------------------------------------//
struct menu_Elements																												
{
	uint8_t element_Number_In_Submenu;																								//    
	uint8_t element_Type;																											// 
	uint8_t child_Submenu;																											//  
	__flash const char *text;																										//     
	uint8_t *data;																													//    
} menu_Elements[MAX_ELEMENTS_MENU+1];																								//  ,         

//-------------------------------------------    -----------------------------------------------------------//
struct submenu																														
{
	uint8_t elements_Count_In_Submenu;																								//    
	uint8_t parent_Submenu_Number;																									//  
}submenu[MAX_SUB_MENUS+1];																											// ,         

//====================================      =======================================================//
//    menu_Elements.         .
//  :
//           number_Element -    ,      ,      .
//element_Number_In_Submenu -    .
//             element_Type -  .
//            child_Submenu -   .
//                    *text -      .
//                    *data -     .
void Add_New_Element(const uint8_t number_Element, uint8_t element_Number_In_Submenu, menu_Types element_Type,  uint8_t child_Submenu, __flash const char *text, uint8_t *data)	
{
	static uint16_t count = 0;																										//   
	if (count > MAX_ELEMENTS_MENU) return;																							//  
	menu_Elements[count].element_Number_In_Submenu = element_Number_In_Submenu;
	menu_Elements[count].element_Type = element_Type;
	menu_Elements[count].child_Submenu = child_Submenu;																				//   
	menu_Elements[count].text = text;
	menu_Elements[count].data = data;
	count++;
}

//===========================================     =======================================================//
//    submenu.
//  :
//              number_Menu -    ,      ,     .
//elements_Count_In_Submenu -    .
//    parent_Submenu_Number -    .
void Add_New_Menu(const uint8_t number_Menu,uint8_t elements_Count_In_Submenu, uint8_t parent_Submenu_Number)
{
	static uint16_t count = 0;																										//  
	if (count > MAX_SUB_MENUS) return;																								//  
	submenu[count].elements_Count_In_Submenu = elements_Count_In_Submenu;															//  
	submenu[count].parent_Submenu_Number = parent_Submenu_Number;
	count++;
}

//=====================================      =============================================//
//  :
//element_Count -      .
//submenu_Count -   .
void _Selected_Element_Calculate(uint8_t element_Count, uint8_t submenu_Count)
{
	_selected_Element = 0;																											//     
	if (submenu_Count != 0)																											//   
	{
		for (int i = 0; i <submenu_Count; i++) _selected_Element = _selected_Element + submenu[i].elements_Count_In_Submenu;		//  
	}
	_selected_Element += element_Count;
}

//=====================================     =====================================================//
//    temp_Array  temp_Switch        .
//  :
//            type -    .
//selected_Element -     .
// :
//			 count -     . 
 uint8_t _Temp_Array_First_Out(uint8_t type, uint16_t selected_Element)
 {
 	uint8_t* temp = 0;																												// 
 	static uint8_t count = 0;																										//    
 	
 	temp = menu_Elements[selected_Element].data;																					//       
 	switch (menu_Elements[selected_Element].element_Type)																													
 	{
 		case PARAM_ELEMENT:																											//     
 			if (*temp == '-' || *temp == '+') count = 6;																			//     
 			else count = 5;
 			
 			for (int i = 0; i < count; i++)
 			{
				_temp_Array[i] = *temp;
 				temp++;
 			}
		break; 		
 		case SWITCH_ELEMENT: _temp_Switch = *temp; break;																			//     
		case WORD_ELEMENT:																											//     
			for (int i = 0; i < MAX_WORD_LENGHT; i++)
			{
				_temp_Array[i] = *temp;
				temp++;
			}
		break;
 	}
 	return count;
 }


//======================================      ========================================================//
//  :
//element_Count -      .
//submenu_Count -   .
//   cursor_Pos -     (   ).
void _Display_Out(uint8_t element_Count, uint8_t submenu_Count, uint8_t cursor_Pos)
{
	__flash const char *array_Byte = 0;																								//         FLASH
	static uint8_t count = 0;																										//      
	uint8_t temp;																													// 
	
	_Selected_Element_Calculate(element_Count, submenu_Count);																		//     
	array_Byte = menu_Elements[_selected_Element].text;																				//       
	
	switch (menu_Elements[_selected_Element].element_Type)
	{
//---------------------   ,     -------------------------------------------------//
		case HISTORY_ELEMENT:																										//   -     
			if (_history_Buf_Name[0][0] == 0)																						//  
			{
				LED_SetPos(0,0);
				array_Byte = menu_Elements[_selected_Element].text;																	// ,     FLASH
				for (int i = 0; ; i++)
				{
					if (*array_Byte == 0) break;
					_LED_Write_Char(*array_Byte);
					array_Byte++;
				}
			}
			else																													//    																
			{
				LED_SetPos(0,0);
				for (int i = 0; i < MAX_HISTORY_NAMES; i++)																			//      
				{
					if (_history_Buf_Name[_line2][i] == 0) break;
					_LED_Write_Char(_history_Buf_Name[_line2][i]);
				}
				
				
				temp = _line-_line2;																								//   
				if (temp < 10)
				{
					LED_SetPos(0, 14);
					_LED_Write_Char((char)(temp+0x30));																				//          
				}
				else
				{
					LED_SetPos(0, 14);
					_LED_Write_Char((char)((temp/10)+0x30));
					LED_SetPos(0, 15);
					_LED_Write_Char((char)((temp%10)+0x30));
				}
				temp = 5;																											//       
				
				LED_SetPos(1,0);
				switch (_history_Buf_Param[_line2][MAX_WORD_LENGHT])																											
				{
					case PARAM_ELEMENT:																								//   - 
						if (_history_Buf_Param[_line2][0] == '-' || _history_Buf_Param[_line2][0] == '+') temp = 6;
						for (int i = 0; i < temp; i++) _LED_Write_Char(_history_Buf_Param[_line2][i]);
					break;
					
					case SWITCH_ELEMENT:																							//   - 
						if (_history_Buf_Param[_line2][0] == 0) LED_Write_String_P(PSTR(""));
						else if(_history_Buf_Param[_line2][0] == 1) LED_Write_String_P(PSTR(""));
					break;
					
					case WORD_ELEMENT:																								//   - 
						for (int i = 0; i < MAX_WORD_LENGHT; i++) _LED_Write_Char(_history_Buf_Param[_line2][i]);
					break;
				}
			}
		break;

//----------------------------------------      -----------------------------------------------//
		default:																													//     
			LED_SetPos(0,0);
			for (int i = 0; i < 32; i++)
			{
				if (*array_Byte == 0)																								//   
				{
					break;
				}
				else if (*array_Byte == '/')																						//   
				{
					array_Byte++;
					if (*array_Byte == 'n')
					{
						array_Byte++;
						LED_SetPos(1,0);
					}
					else
					{
						array_Byte--;
					}
				}
				_LED_Write_Char(*array_Byte);																						//   
				array_Byte++;
			}
			
			if (menu_Elements[_selected_Element].element_Type != EMPTY_ELEMENT && (my_Lib_Flags & lib_Flag_Save_Change) == 0)		//   -          
			{
				//           
				if ((my_Lib_Flags & lib_Flag_Changing_Param) == 0) count = _Temp_Array_First_Out(menu_Elements[_selected_Element].element_Type, _selected_Element);
			}
			
			switch (menu_Elements[_selected_Element].element_Type)
			{
				case SWITCH_ELEMENT:																								//   - 
					if (menu_Elements[_selected_Element].data != 0)
					{
						LED_SetPos(1,0);
						if (_temp_Switch == 1) LED_Write_String_P(PSTR(""));														//    
						else if (_temp_Switch == 0)LED_Write_String_P(PSTR(""));
					}
				break;
				
				case PARAM_ELEMENT:																									//  -  
					if (menu_Elements[_selected_Element].data != 0)																	//        0
					{
						LED_SetPos(1,0);
						for (int i = 0; i < count; i++) _LED_Write_Char(_temp_Array[i]);											//    
					}
				break;
				
				case WORD_ELEMENT:																									//  -  
					if (menu_Elements[_selected_Element].data != 0)																	//        0
					{
						LED_SetPos(1,0);
						for (int i = 0; i < MAX_WORD_LENGHT; i++) _LED_Write_Char(_temp_Array[i]);									//    
					}
				break;
			}
			
			if (my_Lib_Flags & lib_Flag_Changing_Param)																				//   
			{
				switch(menu_Elements[_selected_Element].element_Type)																// 
				{
					case PARAM_ELEMENT: LED_SetPos(1, cursor_Pos); break;
					case WORD_ELEMENT: LED_SetPos(1, cursor_Pos); break;
				}
			}
	}
}

//=================================      ================================================//
//           ,     .
//          menu_Elements[selectedElement].data    menu_Elements[selectedElement].text
void _History_Save(void)
{
	uint8_t *array_Byte_Param = 0;																									//   
	__flash const char *array_Byte_Name = 0;																						//   
	uint8_t count = 5;																												//     
	
	array_Byte_Param = menu_Elements[_selected_Element].data;																		//    
	array_Byte_Name = menu_Elements[_selected_Element].text;
	
//-----------------------------   ,     ----------------------------------------------------//
	if ((my_Lib_Flags & lib_Flag_FIFO_End) == 0)																					//     
	{
		switch (menu_Elements[_selected_Element].element_Type)
		{
			case PARAM_ELEMENT:																										//    
				if (*array_Byte_Param == '-' || *array_Byte_Param == '+') count = 6;												//  
				for (int i = 0; i < count; i++)																						//   
				{
					_history_Buf_Param[_line][i] = *array_Byte_Param;
					array_Byte_Param++;
				}
				_history_Buf_Param[_line][MAX_WORD_LENGHT] = PARAM_ELEMENT;																									
			break;
			
			case SWITCH_ELEMENT:																									//    - 
				_history_Buf_Param[_line][0] = *array_Byte_Param;																	//   
				_history_Buf_Param[_line][MAX_WORD_LENGHT] = SWITCH_ELEMENT;
			break;
			
			case WORD_ELEMENT:																										//    
				for (int i = 0; i < MAX_WORD_LENGHT; i++)																			//   
				{
					_history_Buf_Param[_line][i] = *array_Byte_Param;
					array_Byte_Param++;
				}
				_history_Buf_Param[_line][MAX_WORD_LENGHT] = WORD_ELEMENT;
			break;
		}
		
		for (int i = 0; i < MAX_HISTORY_NAMES; i++)																					//    
		{
			if (*array_Byte_Name == 0) break;																						//   
			_history_Buf_Name[_line][i] = *array_Byte_Name;
			array_Byte_Name++;
		}
		
		if (_line == MAX_HISTORY_ELEMENTS - 1) my_Lib_Flags |= lib_Flag_FIFO_End;													//     

		_line2 = _line;																												//  ,          
		_line++;
	}
//---------------------------------   ,    --------------------------------------------------------//
	else																															//  
	{
		_line = MAX_HISTORY_ELEMENTS - 1;
		_line2 = _line;
		for (int i = 0; i < MAX_HISTORY_ELEMENTS-1; i++)																			//        
		{
			switch (_history_Buf_Param[i+1][MAX_WORD_LENGHT])
			{
				case SWITCH_ELEMENT:																								//   - 
					_history_Buf_Param[i][0] = _history_Buf_Param[i+1][0];
					_history_Buf_Param[i][MAX_WORD_LENGHT] = _history_Buf_Param[i+1][MAX_WORD_LENGHT];
				break;
				
				case PARAM_ELEMENT:																									//   - 
					if (_history_Buf_Param[i+1][0] == '-' || _history_Buf_Param[i+1][0] == '+') count = 6;							//   
					for (int j = 0; j < count; j++)
					{
						_history_Buf_Param[i][j] = _history_Buf_Param[i+1][j];
					}
					_history_Buf_Param[i][MAX_WORD_LENGHT] = _history_Buf_Param[i+1][MAX_WORD_LENGHT];
				break;
				
				case WORD_ELEMENT:																									//   
					for (int j = 0; j < MAX_WORD_LENGHT; j++)
					{
						_history_Buf_Param[i][j] = _history_Buf_Param[i+1][j];
					}
					_history_Buf_Param[i][MAX_WORD_LENGHT] = _history_Buf_Param[i+1][MAX_WORD_LENGHT];
				break;
			}
			
			for (int j = 0; j < MAX_HISTORY_NAMES; j++)																				//        
			{
				_history_Buf_Name[i][j] = _history_Buf_Name[i+1][j];
			}
		}

//------------------------        ---------------------------------------------------------//
		switch (menu_Elements[_selected_Element].element_Type)																		//  
		{
			case PARAM_ELEMENT:																										//   - 
				if (*array_Byte_Param == '-' || *array_Byte_Param == '+') count = 6;
				for (int i = 0; i < count; i++)
				{
					_history_Buf_Param[_line][i] = *array_Byte_Param;
					array_Byte_Param++;
				}
				_history_Buf_Param[_line][MAX_WORD_LENGHT] = PARAM_ELEMENT;
			break;
			
			case SWITCH_ELEMENT:																									//   - 
				_history_Buf_Param[_line][0] = *array_Byte_Param;
				_history_Buf_Param[_line][MAX_WORD_LENGHT] = SWITCH_ELEMENT;
			break;
			
			case WORD_ELEMENT:																										//   - 
				for (int i = 0; i < MAX_WORD_LENGHT; i++)
				{
					_history_Buf_Param[_line][i] = *array_Byte_Param;
					array_Byte_Param++;
				}
				_history_Buf_Param[_line][MAX_WORD_LENGHT] = WORD_ELEMENT;
			break;
		}
		
		for (int i = 0; i < MAX_HISTORY_NAMES; i++)																					//  
		{
			if (*array_Byte_Name == 0) break;																						//   
			_history_Buf_Name[_line][i] = *array_Byte_Name;
			array_Byte_Name++;
		}
		
		_line = MAX_HISTORY_ELEMENTS;
	}
}


//================================================    ===================================================//
//  :
//             key -   . 
//      cursor_Pos -  .
//selected_Element -    .
// :
//cursor_Pos -     (  _Display_Out()).
uint8_t _New_Param(uint8_t key, uint8_t cursor_Pos, uint8_t selected_Element)
{
	uint8_t max_lenght = 0;																											//    
	uint8_t point = 0;																												//   
	if (_temp_Array[0] == '-' || _temp_Array[0] == '+') max_lenght = 6;																//  
	else max_lenght = 5;
	
//----------------------------------------     0 -----------------------------------------------------------//
	if (key == 0)																													//   
	{
		switch (menu_Elements[selected_Element].element_Type)
		{
			case WORD_ELEMENT:																										//     
				cursor_Pos++;
				if (cursor_Pos >= MAX_WORD_LENGHT) cursor_Pos = 0;																	//  
			break;
			default:																												//  
				cursor_Pos++;
				if (cursor_Pos >= max_lenght) cursor_Pos = 0;																		//  
		}
	}
	else
	{
		for (int i = 0; i < max_lenght; i++) 																						//     
		{
			if (_temp_Array[i] == '.') point = 1;
		}
		switch (key)
		{
//----------------------------------------     1 -----------------------------------------------------------//
			case 1:																													//    
				switch (menu_Elements[selected_Element].element_Type)
				{
					case SWITCH_ELEMENT:																							//     - 
						if (_temp_Switch == 0) _temp_Switch = 1;																	//   0  1 -  1  0
						else _temp_Switch = 0;
					break;
					
					case PARAM_ELEMENT:																								//     
						if (_temp_Array[cursor_Pos] == '+')																			//      +  -
						{
							_temp_Array[cursor_Pos] = '-';
						}
						else if (_temp_Array[cursor_Pos] == '-')
						{
							_temp_Array[cursor_Pos] = '+';
						}
						else
						{
							_temp_Array[cursor_Pos]++;																				//     '+/-'   
							if (cursor_Pos == 0 || cursor_Pos == max_lenght-1 || point == 1)										//       ,    
							{	
								if (_temp_Array[cursor_Pos] > 0x39) _temp_Array[cursor_Pos] = 0x30;									//   0  9
								else if(_temp_Array[cursor_Pos] < 0x30) _temp_Array[cursor_Pos] = 0x30;															
							}
							else
							{
								if (cursor_Pos == 1)																				//     1
								{
									if (_temp_Array[0] == '+' || _temp_Array[0] == '-')												//    '+/-'
									{
										if (_temp_Array[cursor_Pos] > 0x39) _temp_Array[cursor_Pos] = 0x30;							//    0  9
										else if(_temp_Array[cursor_Pos] < 0x30) _temp_Array[cursor_Pos] = 0x30;
									}
									else																							//    0  9  '.'
									{
										if (_temp_Array[cursor_Pos] > 0x39) _temp_Array[cursor_Pos] = 0x2E;
										else if(_temp_Array[cursor_Pos] < 0x30) _temp_Array[cursor_Pos] = 0x30;
									}
								}
								else																								//     
								{
									if (_temp_Array[cursor_Pos] > 0x39) _temp_Array[cursor_Pos] = 0x2E;								//   0  9  '.'
									else if(_temp_Array[cursor_Pos] < 0x30) _temp_Array[cursor_Pos] = 0x30;
								}
							}
						}
					break;
					
					case WORD_ELEMENT:																								//     
						_temp_Array[cursor_Pos]++;																					//  
						if (_temp_Array[cursor_Pos] == '' + 1) _temp_Array[cursor_Pos] = '0';
						else if (_temp_Array[cursor_Pos] == '9' + 1)  _temp_Array[cursor_Pos] = '.';								//     
						else if (_temp_Array[cursor_Pos] == '.' + 1)  _temp_Array[cursor_Pos] = '/';
						else if (_temp_Array[cursor_Pos] == '/' + 1)  _temp_Array[cursor_Pos] = '^';
						else if (_temp_Array[cursor_Pos] == '^' + 1)  _temp_Array[cursor_Pos] = ' ';
						else if (_temp_Array[cursor_Pos] == ' ' + 1)  _temp_Array[cursor_Pos] = '';
					break;
				}
			break;
			
//----------------------------------------     2 -----------------------------------------------------------//
			case 2:																													//   
				switch (menu_Elements[selected_Element].element_Type)
				{
					case SWITCH_ELEMENT:																							//     - 
						if (_temp_Switch == 0) _temp_Switch = 1;																	//   0  1 -  1  0
						else _temp_Switch = 0;
					break;
					
					case PARAM_ELEMENT:																								//     
						if (_temp_Array[cursor_Pos] == '+')																			//      +  -
						{
							_temp_Array[cursor_Pos] = '-';
						}
						else if (_temp_Array[cursor_Pos] == '-')
						{
							_temp_Array[cursor_Pos] = '+';
						}
						else
						{
							_temp_Array[cursor_Pos]--;																				//     '+/-'   
							if (cursor_Pos == 0 || cursor_Pos == max_lenght-1 || point == 1)										//       ,    
							{
								if (_temp_Array[cursor_Pos] < 0x30) _temp_Array[cursor_Pos] = 0x39;									//   0  9
							}
							else
							{
								if (cursor_Pos == 1)																				//     1
								{
									if (_temp_Array[0] == '+' || _temp_Array[0] == '-')												//    '+/-'
									{
										if (_temp_Array[cursor_Pos] < 0x30) _temp_Array[cursor_Pos] = 0x39;							//    0  9
									}
									else																							//    0  9  '.'
									{
										if (_temp_Array[cursor_Pos] < 0x2E) _temp_Array[cursor_Pos] = 0x39;
										else if (_temp_Array[cursor_Pos] < 0x30) _temp_Array[cursor_Pos] = 0x2E;
									}
								}
								else																								//     
								{
									if (_temp_Array[cursor_Pos] < 0x2E) _temp_Array[cursor_Pos] = 0x39;								//   0  9  '.'
									else if (_temp_Array[cursor_Pos] < 0x30) _temp_Array[cursor_Pos] = 0x2E;
								}
							}
						}
					break;
					
					case WORD_ELEMENT:																								//     
						_temp_Array[cursor_Pos]--;																					//  
						if (_temp_Array[cursor_Pos] == '' - 1) _temp_Array[cursor_Pos] = ' ';
						else if (_temp_Array[cursor_Pos] == ' ' - 1) _temp_Array[cursor_Pos] = '^';									//     
						else if (_temp_Array[cursor_Pos] == '^' - 1) _temp_Array[cursor_Pos] = '/';
						else if (_temp_Array[cursor_Pos] == '/' - 1) _temp_Array[cursor_Pos] = '.';
						else if (_temp_Array[cursor_Pos] == '.' - 1) _temp_Array[cursor_Pos] = '9';
						else if (_temp_Array[cursor_Pos] == '0' - 1) _temp_Array[cursor_Pos] = '';
						
					break;
				}
			break;
		}
	}
	return cursor_Pos;																												//   
}

//====================================      ==============================================//
//  :
//*array_Byte -     .
//      *type -      .
// :
//selected_Element -   ,   .
uint8_t _Menu_Data_Change(uint8_t *array_Byte, uint8_t *type)
{
	if (my_Lib_Flags & lib_Flag_Save_Change)																						//    
	{	
		my_Lib_Flags &= ~lib_Flag_Save_Change;																						//   
		switch (menu_Elements[_selected_Element].element_Type)
		{
			case PARAM_ELEMENT:																										//    
				for (int i = 0; i < 6; i++)
				{
					*array_Byte = _temp_Array[i];																					//    
					array_Byte++;
				}
				*type = PARAM_ELEMENT;																								//     
				break;
			
			case SWITCH_ELEMENT:																									//    - 
				*array_Byte = _temp_Switch;																							//    
				*type = SWITCH_ELEMENT;
				break;
			
			case DEFAULT_ELEMENT:																									//     
				for (int i = 0; i < 6; i++)
				{
					*array_Byte = 0;																								// 
					array_Byte++;
				}
				*type = DEFAULT_ELEMENT;																							//     
				break;
			
			case WORD_ELEMENT:																										//    
				for (int i = 0; i < 8; i++)
				{
					*array_Byte = _temp_Array[i];																					//   
					array_Byte++;
				}
				*type = WORD_ELEMENT;
				break;
		}
		return _selected_Element;																									//     
 	}
 	else
 	{
 		return NONE;																												//     0
 	}
}

//=============================================     ==============================================//
//        ,         
//  :
//   *ptr -        .
//element -   .
void Save_Changes(uint16_t element, uint8_t *ptr)
{
	uint8_t count = 0;
	uint8_t *ptr_Data = menu_Elements[element].data;
	_History_Save();																													//     
	switch (menu_Elements[element].element_Type)																					//      
	{
		case SWITCH_ELEMENT:																										//   - 
			*ptr_Data = *ptr;
			break;

		case PARAM_ELEMENT:																											//   
			count = 5;
			if (*ptr == '-' || *ptr == '+') count = 6;																				//  
			for (int i = 0; i < count; i++)
			{
				*ptr_Data = *ptr;
				ptr_Data++;
				ptr++;
			}
			break;
		
		case WORD_ELEMENT:																											//   
			count = 8;
			for (int i = 0; i < count; i++)
			{
				if (*ptr == 0) break;																								//      
				
				*ptr_Data = *ptr;
				ptr_Data++;
				ptr++;
			}
			break;
	}
}
//==============================================    =============================================================//
//    .
uint16_t Goto_Menu (uint8_t *array_Byte, uint8_t *type)
{
	my_Lib_Flags |= lib_Flag_Menu_Enable | lib_Flag_Set_Changes;																	//  (" "  "  ")
	while(1)
	{
		static uint8_t element_Count = 0;																							//      
		static uint8_t submenu_Count = 0;																							//  
		static uint8_t cursor_Pos = 255;																							// 
		static uint8_t led_Curs = 0;																								//       
		static uint8_t state = 0;																									//       
		uint8_t stop = 0;																											// 
		uint8_t *temp_Byte = 0;																										//     
		
		my_Lib_Flags &= ~lib_Flag_Save_Change;
		
//---------------------------------------       --------------------------------------------------------//
		if (my_Lib_Flags & lib_Flag_Menu_Out)
		{
			my_Lib_Flags &= ~lib_Flag_Menu_Out;
			element_Count = 0;
			submenu_Count = 0;
		}

//-------------------------------------------------   0 -------------------------------------------------------------//
		_Selected_Element_Calculate(element_Count, submenu_Count);																	//    
		if (Key(0) == 1)																											//   0
		{
			uint16_t time_Down = 0;																									//  
			while(Key(0) == 1)
			{
				_delay_ms(10);																										//
				if (my_Lib_Flags & lib_Flag_Changing_Param)
				{
					if (time_Down < 300)
					{
						time_Down++;																								//        3 
					}
					else
					{
						LED_SetPos(1, 17);																							//    
						cursor_Pos = 255;																							//    
						stop = 1;																									//   
						my_Lib_Flags |= lib_Flag_Save_Change;																		//   
						my_Lib_Flags &= ~lib_Flag_Changing_Param;																	//   
						Led(1);																										// 
					}
				}
				else if (menu_Elements[_selected_Element].element_Type == DEFAULT_ELEMENT)											//    ,     
				{
					if (time_Down < 300)
					{
						time_Down++;																								//        3 
					}
					else
					{
						my_Lib_Flags |= lib_Flag_Save_Change;																		//   
						my_Lib_Flags &= ~lib_Flag_Menu_Enable;																		//   
						element_Count = 0;																							//  
						submenu_Count = 0;
						Led(1);																										// 
					}
				}
				
				if ((my_Lib_Flags & lib_Flag_Changing_Param) && menu_Elements[_selected_Element].element_Type == SWITCH_ELEMENT)	//         - 
				{
					if (led_Curs < 50)
					{
						led_Curs++;																									//   10    500 
					}
					else
					{
						led_Curs = 0;																								// 
						LED_SetPos(1,0);
						if (state != 0)																								//  
						{
							state = 0;
							if (_temp_Switch != 0) LED_Write_String_P(PSTR(""));													// 
							else LED_Write_String_P(PSTR(""));
						}
						else																										//  
						{
							state = 1;
							LED_Write_String_P(PSTR("    "));																		// 
						}
					}
					LED_SetPos(1,17);																								//    
				}
				else if ((my_Lib_Flags & lib_Flag_Save_Change) && menu_Elements[_selected_Element].element_Type == SWITCH_ELEMENT && stop == 1)//   stop == 1
				{
					LED_SetPos(1,0);
					if (_temp_Switch != 0) LED_Write_String_P(PSTR(""));															//  
					else LED_Write_String_P(PSTR(""));
					LED_SetPos(1,17);
					stop = 0;																										// 
				}
			}
			
			
			if (menu_Elements[_selected_Element].child_Submenu != 0)																//     
			{
				element_Count = 0;
				submenu_Count = menu_Elements[_selected_Element].child_Submenu;														//   
			}
			else
			{
				if (my_Lib_Flags & lib_Flag_Save_Change)																			//    
				{
					my_Lib_Flags &= ~lib_Flag_Changing_Param;																		//   
				}
				//    , ,   
				else if (menu_Elements[_selected_Element].element_Type == SWITCH_ELEMENT || menu_Elements[_selected_Element].element_Type == PARAM_ELEMENT || menu_Elements[_selected_Element].element_Type == WORD_ELEMENT)
				{
					my_Lib_Flags |= lib_Flag_Changing_Param;																		//   
					if (menu_Elements[_selected_Element].element_Type == PARAM_ELEMENT) cursor_Pos = _New_Param(0, cursor_Pos, _selected_Element);// 
					if (menu_Elements[_selected_Element].element_Type == WORD_ELEMENT) cursor_Pos = _New_Param(0, cursor_Pos, _selected_Element);
				}
			}
			my_Lib_Flags |= lib_Flag_Set_Changes;																					//    
			Led(0);																													// 
		}

//------------------------------------------------------   3 --------------------------------------------------------//
		if (Key(3) == 1)																											//   
		{
			while(Key(3) == 1){_delay_ms(10);}																						//

			if (submenu_Count != 0)																									//    
			{
				if (my_Lib_Flags & lib_Flag_Changing_Param)																			//   
				{
					switch(menu_Elements[_selected_Element].element_Type)
					{
						case PARAM_ELEMENT:																							//     
						temp_Byte = menu_Elements[_selected_Element].data;															//       
						for (int i = 0; i < sizeof(_temp_Array); i++)
						{
							_temp_Array[i] = *temp_Byte;																			//  
							temp_Byte++;
						}
						break;
						
						case SWITCH_ELEMENT:																						//     
						_temp_Switch = *menu_Elements[_selected_Element].data;														//  
						break;
					}
				}
				else																												//    
				{
					for (int i = 0; i < MAX_ELEMENTS_MENU; i++)																		//  
					{
						if (menu_Elements[i].child_Submenu == submenu_Count)														//         
						{																											//     
							if (submenu[submenu_Count].parent_Submenu_Number == 0)													//   -  
							{
								element_Count = menu_Elements[i].element_Number_In_Submenu;											//      
								break;
							}
							else
							{
								uint16_t temp = 0;																					// 
								uint16_t temp2 = 0;
								for (int s = 0; s < MAX_ELEMENTS_MENU; s++)
								{
									temp2 = temp;
									temp = temp + submenu[s].elements_Count_In_Submenu;												//       n
									
									if (temp > i)																					//    
									{
										element_Count = i - temp2;																	// 
										break;
									}
								}
								break;
							}
						}
					}
					submenu_Count = submenu[submenu_Count].parent_Submenu_Number;													//  
				}
			}
			else																													//   
			{
				my_Lib_Flags &= ~lib_Flag_Menu_Enable;																				//  " "
				my_Lib_Flags |= lib_Flag_Menu_Out;																					//  "  "
				LED_Clear();																										// 
				return EXIT;																										//   
			}
			
			cursor_Pos = 255;																										//  
			_line2 = _line - 1;																										//     ( )
			my_Lib_Flags &= ~lib_Flag_Changing_Param;																				//   
			my_Lib_Flags |= lib_Flag_Set_Changes;																					//    
		}
		
//---------------------------------------------------   1 -----------------------------------------------------------//
		if (Key(1) == 1)																											//   
		{
			while(Key(1) == 1){_delay_ms(10);}																						//
			
			if (my_Lib_Flags & lib_Flag_Changing_Param)																				//    
			{
				_New_Param(1, cursor_Pos, _selected_Element);																		//     
			}
			else
			{
				if (menu_Elements[_selected_Element].element_Type == HISTORY_ELEMENT)												//      
				{
					_line2--;
					if (_line2 == 255) _line2 = _line - 1;																			// 
				}
				else
				{
					element_Count++;																								//  
					if (element_Count > submenu[submenu_Count].elements_Count_In_Submenu-1) element_Count = 0;						//    
				}
			}
			my_Lib_Flags |= lib_Flag_Set_Changes;																					//     
		}

//---------------------------------------------------   2 -----------------------------------------------------------//
		if (Key(2) == 1)																											//   
		{
			while(Key(2) == 1){_delay_ms(10);}																						//
			
			if (my_Lib_Flags & lib_Flag_Changing_Param)																				//    
			{
				_New_Param(2, cursor_Pos, _selected_Element);																		//   
			}
			else
			{
				if (menu_Elements[_selected_Element].element_Type == HISTORY_ELEMENT)												//      
				{

					_line2++;
					if (_line2 > _line - 1) _line2 = 0;																				// 
				}
				else
				{
					if (element_Count == 0) element_Count = submenu[submenu_Count].elements_Count_In_Submenu-1;						//    
					else element_Count--;																							//  
				}
			}
			my_Lib_Flags |= lib_Flag_Set_Changes;																					//     
		}
		
//-----------------------------------------    ------------------------------------------------------------------//
		if ((my_Lib_Flags & lib_Flag_Changing_Param) && menu_Elements[_selected_Element].element_Type == SWITCH_ELEMENT)			//          - 
		{
			if (led_Curs < 100)
			{
				_delay_ms(5);
				led_Curs++;																											// 
			}
			else																													//   500 
			{
				led_Curs = 0;																										// 
				LED_SetPos(1,0);
				if (state != 0)																										//  
				{
					state = 0;
					if (_temp_Switch != 0) LED_Write_String_P(PSTR(""));															// 
					else LED_Write_String_P(PSTR(""));
				}
				else																												//  
				{
					state = 1;
					LED_Write_String_P(PSTR("    "));																				// 
				}
			}
			LED_SetPos(1,5);
		}
		
//----------------------------------------     ------------------------------------------------------------//
		if ( my_Lib_Flags & lib_Flag_Set_Changes)																					//      
		{
			LED_Clear();																											// 
			my_Lib_Flags &= ~lib_Flag_Set_Changes;																					//     
			_Display_Out(element_Count, submenu_Count, cursor_Pos);																	//     
		}
		
		uint16_t ret = _Menu_Data_Change(array_Byte, type);																			//   
		if (ret != NONE) return ret;
	}
}
#endif
